From 073dbf58ea2a8d019ae075cfa41e87d9de047630 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 02 2020 04:18:17 +0000
Subject: [PATCH 803/2232] Continue if target dir not found


---

diff --git a/gen/build/src/cargo.rs b/gen/build/src/cargo.rs
index 3bddc6e..6a4f1a6 100644
--- a/gen/build/src/cargo.rs
+++ b/gen/build/src/cargo.rs
@@ -1,19 +1,18 @@
-use crate::error::TargetDirError;
 use crate::paths::TargetDir;
 use std::path::PathBuf;
 use std::process::Command;
 use std::str;
 
-pub(crate) fn target_dir() -> Result<TargetDir, TargetDirError> {
-    let cargo = option_env!("CARGO").unwrap_or("cargo");
-    let output = Command::new(cargo)
-        .arg("metadata")
-        .arg("--no-deps")
-        .arg("--format-version=1")
-        .output()
-        .map_err(TargetDirError::Io)?;
-
+pub(crate) fn target_dir() -> TargetDir {
     (|| {
+        let cargo = option_env!("CARGO").unwrap_or("cargo");
+        let output = Command::new(cargo)
+            .arg("metadata")
+            .arg("--no-deps")
+            .arg("--format-version=1")
+            .output()
+            .ok()?;
+
         // Cargo only outputs utf8 encoded JSON.
         let mut metadata = str::from_utf8(&output.stdout).ok()?;
 
@@ -25,7 +24,7 @@ pub(crate) fn target_dir() -> Result<TargetDir, TargetDirError> {
         let close_quote_index = metadata.find('"')?;
         let string = &metadata[..close_quote_index];
         let target_directory = string.replace("\\\\", "\\");
-        Some(TargetDir(PathBuf::from(target_directory)))
+        Some(TargetDir::Path(PathBuf::from(target_directory)))
     })()
-    .ok_or(TargetDirError::NotFound)
+    .unwrap_or(TargetDir::Unknown)
 }
diff --git a/gen/build/src/error.rs b/gen/build/src/error.rs
index ed4c6af..0ed4d74 100644
--- a/gen/build/src/error.rs
+++ b/gen/build/src/error.rs
@@ -1,28 +1,19 @@
 use crate::gen::fs;
 use std::error::Error as StdError;
 use std::fmt::{self, Display};
-use std::io;
 
 pub(super) type Result<T, E = Error> = std::result::Result<T, E>;
 
 #[derive(Debug)]
 pub(super) enum Error {
     MissingOutDir,
-    TargetDir(TargetDirError),
     Fs(fs::Error),
 }
 
-#[derive(Debug)]
-pub(crate) enum TargetDirError {
-    Io(io::Error),
-    NotFound,
-}
-
 impl Display for Error {
     fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
         match self {
             Error::MissingOutDir => write!(f, "missing OUT_DIR environment variable"),
-            Error::TargetDir(_) => write!(f, "unable to identify target dir"),
             Error::Fs(err) => err.fmt(f),
         }
     }
@@ -31,10 +22,6 @@ impl Display for Error {
 impl StdError for Error {
     fn source(&self) -> Option<&(dyn StdError + 'static)> {
         match self {
-            Error::TargetDir(err) => match err {
-                TargetDirError::Io(err) => Some(err),
-                TargetDirError::NotFound => None,
-            },
             Error::Fs(err) => err.source(),
             _ => None,
         }
diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index 2f94426..111f592 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -59,7 +59,7 @@ mod gen;
 mod paths;
 mod syntax;
 
-use crate::error::{Error, Result};
+use crate::error::Result;
 use crate::gen::error::report;
 use crate::gen::{fs, Opt};
 use crate::paths::TargetDir;
@@ -99,7 +99,7 @@ pub fn bridges(rust_source_files: impl IntoIterator<Item = impl AsRef<Path>>) ->
 }
 
 fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Result<Build> {
-    let ref target_dir = target_dir()?;
+    let ref target_dir = target_dir();
     let mut build = paths::cc_build(target_dir);
     build.cpp(true);
     build.cpp_link_stdlib(None); // linked via link-cplusplus crate
@@ -152,15 +152,10 @@ fn write(path: &Path, content: &[u8]) -> Result<()> {
     Ok(())
 }
 
-fn target_dir() -> Result<TargetDir> {
-    let fallback_err = match cargo::target_dir() {
-        Ok(target_dir) => return Ok(target_dir),
-        Err(err) => Error::TargetDir(err),
-    };
-
-    // Fallback if Cargo did not work.
-    match paths::search_parents_for_target_dir() {
-        Some(target_dir) => Ok(target_dir),
-        None => Err(fallback_err),
+fn target_dir() -> TargetDir {
+    match cargo::target_dir() {
+        target_dir @ TargetDir::Path(_) => target_dir,
+        // Fallback if Cargo did not work.
+        TargetDir::Unknown => paths::search_parents_for_target_dir(),
     }
 }
diff --git a/gen/build/src/paths.rs b/gen/build/src/paths.rs
index 47a28a0..1814f82 100644
--- a/gen/build/src/paths.rs
+++ b/gen/build/src/paths.rs
@@ -1,16 +1,11 @@
 use crate::error::{Error, Result};
 use crate::gen::fs;
 use std::env;
-use std::ops::Deref;
 use std::path::{Path, PathBuf};
 
-pub(crate) struct TargetDir(pub PathBuf);
-
-impl Deref for TargetDir {
-    type Target = Path;
-    fn deref(&self) -> &Self::Target {
-        &self.0
-    }
+pub(crate) enum TargetDir {
+    Path(PathBuf),
+    Unknown,
 }
 
 fn out_dir() -> Result<PathBuf> {
@@ -22,13 +17,18 @@ fn out_dir() -> Result<PathBuf> {
 pub(crate) fn cc_build(target_dir: &TargetDir) -> cc::Build {
     let mut build = cc::Build::new();
     build.include(include_dir(target_dir));
-    build.include(target_dir.parent().unwrap());
+    if let TargetDir::Path(target_dir) = target_dir {
+        build.include(target_dir.parent().unwrap());
+    }
     build
 }
 
 // Symlink the header file into a predictable place. The header generated from
-// path/to/mod.rs gets linked to targets/cxxbridge/path/to/mod.rs.h.
+// path/to/mod.rs gets linked to target/cxxbridge/path/to/mod.rs.h.
 pub(crate) fn symlink_header(path: &Path, original: &Path, target_dir: &TargetDir) {
+    if let TargetDir::Unknown = target_dir {
+        return;
+    }
     let _ = try_symlink_header(path, original, target_dir);
 }
 
@@ -49,7 +49,10 @@ fn try_symlink_header(path: &Path, original: &Path, target_dir: &TargetDir) -> R
 }
 
 fn relative_to_parent_of_target_dir(original: &Path, target_dir: &TargetDir) -> Result<PathBuf> {
-    let mut outer = target_dir.parent().unwrap();
+    let mut outer = match target_dir {
+        TargetDir::Path(target_dir) => target_dir.parent().unwrap(),
+        TargetDir::Unknown => unimplemented!(), // FIXME
+    };
     let original = canonicalize(original)?;
     loop {
         if let Ok(suffix) = original.strip_prefix(outer) {
@@ -76,17 +79,23 @@ pub(crate) fn out_with_extension(
 }
 
 pub(crate) fn include_dir(target_dir: &TargetDir) -> PathBuf {
-    target_dir.join("cxxbridge")
+    match target_dir {
+        TargetDir::Path(target_dir) => target_dir.join("cxxbridge"),
+        TargetDir::Unknown => out_dir().unwrap().join("cxxbridge"), // FIXME no unwrap
+    }
 }
 
-pub(crate) fn search_parents_for_target_dir() -> Option<TargetDir> {
-    let mut dir = out_dir().and_then(canonicalize).ok()?;
+pub(crate) fn search_parents_for_target_dir() -> TargetDir {
+    let mut dir = match out_dir().and_then(canonicalize) {
+        Ok(dir) => dir,
+        Err(_) => return TargetDir::Unknown,
+    };
     loop {
         if dir.ends_with("target") {
-            return Some(TargetDir(dir));
+            return TargetDir::Path(dir);
         }
         if !dir.pop() {
-            return None;
+            return TargetDir::Unknown;
         }
     }
 }

